/**
   PowerForms AutoComplete library
   Copyright Mikkel Ricky 2002
*/

function AutoComplete_updateText(state) {
  if (this.state != state) {
    var child = null;
    if (state == PowerForms.ACCEPT) {
      child = this.accept;
    } else if (state == PowerForms.REJECT) {
      child = this.reject;
    } else if (state == PowerForms.CRASH) {
      child = this.crash;
    } else {
      child = this.na;
    }
    if (this.node != null) {
      if (this.node.hasChildNodes()) {
	this.node.replaceChild(child, this.node.firstChild);
      } else {
	this.node.appendChild(child);
      }
    }
    this.state = state;
  }
}

function AutoComplete_updateImage(state) {
  if (this.state != state) {
    /*
    if (!this.node.hasChildNodes()) {
      var img = document.createElement("img");
      this.node.appendChild(img);
    }
    */
    var url;
    if (state == PowerForms.ACCEPT) {
      url = this.accept;
    } else if (state == PowerForms.REJECT) {
      url = this.reject;
    } else if (state == PowerForms.CRASH) {
      url = this.crash;
    } else {
      url = this.na;
    }
    /* this.node.firstChild.setAttribute("src", url); */
    if (this.node != null) {
      if (this.node.setAttribute) {
	this.node.setAttribute("src", url);
      } else {
	this.node.src = url;
      }
    }
    this.state = state;
  }
}

function AutoComplete_setCompletion(completion) {
  this.completion = completion;
  if ((this.completion == null) || (this.completion.length == 0)) {
    this.completion = null;
    if (this.img.setAttribute) {
      this.img.setAttribute("src", this.naurl);
    } else {
      this.img.src = this.naurl;
    }
  } else {
    if (this.img.setAttribute) {
      this.img.setAttribute("src", this.imageurl);
    } else {
      this.img.src = this.imageurl;
    }
  }
  /* confirm(this.img); */
}

function AutoComplete_complete() {
  if (this.completion != null) {
    this.input.value += this.completion;
    if (this.updatefunction != null) {
      this.updatefunction();
    }
    this.setCompletion(null);
  }
  this.input.focus();
}

function AutoComplete(id, inputid, updatefunction, imageurl, naurl) {
  this.img = document.images[id];
  /* this.anchor = document.anchors[id+"-anchor"]; */
  this.input = document.getElementById ? document.getElementById(inputid) : PowerForms.getElementById(inputid);
  this.updatefunction = updatefunction;
  this.imageurl = imageurl;
  this.naurl = naurl;
  this.completion = null;
  this.setCompletion = AutoComplete_setCompletion;
  this.complete = AutoComplete_complete;
}
