function Select_getValues_ns4() {
  var values = new Object();
  for (var i = 0; i < this.options.length; i++) {
    if (this.options[i].selected) {
      values[this.options[i].value] = true;
    }
  }
  return values;
}

function Select_getValues() {
  var values = new Object();
  for (var i = 0; i < this.options.length; i++) {
    if (this.options.item(i).selected) {
      values[this.options.item(i).value] = true;
    }
  }
  return values;
}

function copyOption(option) {
  return new Option(option.text, option.value, option.defaultSelected, option.defaultSelected);
}

function Select_filter_ns4(predicate) {
  var oldValues = this.getValues();
  this.clear();
  var index = -1;
  for (var i = 0; i < this.allOptions.length; i++) {
    var option = this.allOptions[i];
    if (predicate(option.value)) {
      if (oldValues[option.value] && (index < 0)) {
	index = this.options.length;
      }
      this.options[this.options.length] = copyOption(option);
      option.selected = oldValues[option.value];
    }
  }

  /*
  var msg = "";
  for (var value in oldValues) {
    msg += value+" ";
  }
  confirm("oldValues: "+msg+"; index: "+index);
  */

  if (this.type == "select-one") {
    if (this.length == 0) {
      this.options[0] = copyOption(this.errorOption);
    } else {
      if (index >= 0) {
	this.options[index].selected = true;
      }
      for (var i = 0; i < this.options.length; i++) {
	if (oldValues[this.options[i].value]) {
	  /* confirm("selecting "+i+"'th option ("+this.options[i]+") ..."); */
	  this.options[i].selected = true;
	  break;
	}
      }
    }
  }
  var newValues = this.getValues();

  /* Check if values have changed */
  for (var value in oldValues) {
    if (!newValues[value]) {
      return true;
    }
  }
  for (var value in newValues) {
    if (!oldValues[value]) {
      return true;
    }
  }
  return false;
}

function Select_filter(predicate) {
  var oldValues = this.getValues();

  /*
  var msg = "";
  for (var value in values) {
    msg += value+"; ";
  }
  confirm("values: "+msg);
  */

  this.clear();
  var index = -1;
  for (var i = 0; i < this.allOptions.length; i++) {
    var option = this.allOptions[i];
    if (predicate(option.value)) {
      if (oldValues[option.value] && (index < 0)) {
	index = this.options.length;
      }
      if (this.add.length && (this.add.length == 2)) {
	this.add(option, null);
      } else {
	this.add(option);
      }
      option.selected = oldValues[option.value];
    }
  }
  if (!this.multiple) {
    if (index > -1) {
      this.selectedIndex = index;
    } else if (this.length == 0) {
      this.add(this.errorOption, null);
    }
  }
  var newValues = this.getValues();

  /* Check if values have changed */
  for (var value in oldValues) {
    if (!newValues[value]) {
      return true;
    }
  }
  for (var value in newValues) {
    if (!oldValues[value]) {
      return true;
    }
  }
  return false;
}

function Select_clear_ns4() {
  while (this.length > 0) {
    this.options[0] = null;
  }
}

function Select_clear() {
  while (this.length > 0) {
    this.remove(0);
  }
}

function Select_reset() {
  this.filter(function(s) { return true; });
}

function Select_acceptValues(dfa) {
  var values = this.getValues();
  for (var v in values) {
    if (!PowerForms.toBoolean(dfa.run(v))) {
      return false;
    }
  }
  return true;
}

function Select_equalValues(value) {
  var values = this.getValues();
  for (var v in values) {
    if (!PowerForms.toBoolean(PowerForms.equals(v, value))) {
      return false;
    }
  }
  return true;
}

function initSelect(select, errorValue) {
  select.errorValue = errorValue ? errorValue : null;
  if (!select.multiple) {
    var option;
    if (document.createElement) {
      option = document.createElement("option");
      option.setAttribute("value", "errorValue");
      option.appendChild(document.createTextNode("---"));
    } else {
      option = new Option("---", "errorValue", false, false);
    }
    /* select.add(option, select.options.item(0)); */
    select.errorOption = option;
  }

  /* confirm(select); */

  select.allOptions = new Array();
  if (isAcademicBrowser) {
    for (var i = 0; i < select.options.length; i++) {
      select.allOptions[i] = copyOption(select.options[i]);
    }
    select.getValues = Select_getValues_ns4;
    select.filter = Select_filter_ns4;
    select.clear = Select_clear_ns4;
  } else {
    for (var i = 0; i < select.options.length; i++) {
      select.allOptions[i] = select.options.item(i);
    }
    select.getValues = Select_getValues;
    select.filter = Select_filter;
    select.clear = Select_clear;
  }
  select.acceptValues = Select_acceptValues;
  select.equalValues = Select_equalValues;
  select.reset = Select_reset;
}
