/**
   PowerForms Status library
   Copyright Mikkel Ricky 2002
*/

function Status_updateText(state) {
  if (this.state != state) {
    var child = null;
    if (state == PowerForms.ACCEPT) {
      child = this.accept;
    } else if (state == PowerForms.REJECT) {
      child = this.reject;
    } else if (state == PowerForms.CRASH) {
      child = this.crash;
    } else {
      child = this.na;
    }
    if (this.node != null) {
      if (this.node.hasChildNodes()) {
	this.node.replaceChild(child, this.node.firstChild);
      } else {
	this.node.appendChild(child);
      }
    }
    this.state = state;
  }
}

function Status_updateImage(state, help, error, warning) {
  if (this.state != state) {
    /*
    if (!this.node.hasChildNodes()) {
      var img = document.createElement("img");
      this.node.appendChild(img);
    }
    */
    var src;
    var alt = help;
    if (state == PowerForms.ACCEPT) {
      src = this.accept;
    } else if (state == PowerForms.REJECT) {
      src = this.reject;
      alt = warning;
    } else if (state == PowerForms.CRASH) {
      src = this.crash;
      alt = error;
    } else {
      src = this.na;
    }
    /* this.node.firstChild.setAttribute("src", src); */
    if (this.node != null) {
      if (this.node.setAttribute) {
	this.node.setAttribute("src", src);
	this.node.setAttribute("alt", alt);
      } else {
	this.node.src = src;
	this.node.alt = alt;
      }
    }
    this.state = state;
  }
}

function Status_updateCss(state) {
  if (this.state != state) {
    var clazz;
    if (state == PowerForms.ACCEPT) {
      clazz = this.accept;
    } else if (state == PowerForms.REJECT) {
      clazz = this.reject;
    } else if (state == PowerForms.CRASH) {
      clazz = this.crash;
    } else {
      clazz = this.na;
    }
    if (this.node != null) {
      if (!true) {
	if (clazz == this.na) {
	  this.node.setAttribute("disabled", "disabled");
	} else {
	  this.node.removeAttribute("disabled");
	}
	this.node.setAttribute("class", clazz);
      } else {
	this.node.disabled = (clazz == this.na);
	if (this.node.style.className) {
	  this.node.style.className = clazz;
	} else {
	  this.node.className = clazz;
	  /* window.status = "status: "+clazz+"; "+this.node.className; */
	}
      }
    }
    this.state = state;
  }
}

function Status(type, id, na, crash, reject, accept) {
  this.state = 1000;
  if (document.getElementById) {
    this.node = document.getElementById(id);
  } else if (type == PowerForms.IMAGE) {
    this.node = document.images[id];
  } else {
    this.node = null;
  }
  if (type == PowerForms.TEXT) {
    this.na = document.createTextNode(na);
    this.crash = document.createTextNode(crash);
    this.reject = document.createTextNode(reject);
    this.accept = document.createTextNode(accept);
    this.update = Status_updateText;
  } else if (type == PowerForms.IMAGE) {
    /*
      var element = document.createElement("img");
      element.setAttribute("src", na);
      this.na = element;
      element = document.createElement("img");
      element.setAttribute("src", crash);
      this.crash = element;
      element = document.createElement("img");
      element.setAttribute("src", reject);
      this.reject = element;
      element = document.createElement("img");
      element.setAttribute("src", accept);
      this.accept = element;
    */
    this.na = na;
    this.crash = crash;
    this.reject = reject;
    this.accept = accept;
    this.update = Status_updateImage;
  } else if (type == PowerForms.CSS) {
    this.na = na;
    this.crash = crash;
    this.reject = reject;
    this.accept = accept;
    this.update = Status_updateCss;
  }
}
