/**
 * ISBN.java
 *
 *
 * Created: Tue Apr 16 13:10:43 2002
 *
 * @author <a href="mailto:ricky@brics.dk">Mikkel Ricky</a>
 * @version
 */

import dk.brics.automaton.*;
import dk.brics.powerforms.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class ISBN {
  public static void main(String[] args) throws Exception {
    generate();
    /* test(); */
  }

  private static void test() throws Exception {
    URL url = new File("isbn.dfa").toURL();
    Automaton isbn = Automaton.load(url);
    System.err.println("isbn: "+isbn);
    /* Set language = isbn.getFiniteStrings(); */
    /* System.err.println(language); */
  }

  private static void generate() throws Exception {
    List defs = new ArrayList();
    CharArrayWriter chars = new CharArrayWriter();
    PrintWriter out = new PrintWriter(chars);
    out.println("<powerforms>");
    out.println("  <regexp-def id='sep'>");
    out.println("    <optional><const value='-'/></optional>");
    out.println("  </regexp-def>");
    for (int i = 1; i <= 5; i++) {
      for (int j = 0; j <= 10; j++) {
	String name = "isbn"+i+(j == 10 ? "X" : String.valueOf(j));
	defs.add(name);
	out.println("  <regexp-def id='"+name+"'>");
	out.println("    <union>");
	for (int k = 0; k <= 9; k++) {
	  int m = ((j-(10-i)*k)%11+11)%11;
	  if ((i > 1) || (m < 10)) {
	    out.print("      <concat><const value='"+k+"'/><regexp idref='sep'/>");
	    if (i > 1) {
	      if (m < 10) {
		out.println("<regexp idref='isbn"+(i-1)+m+"'/></concat>");
	      } else {
		out.println("<regexp idref='isbn"+(i-1)+"X'/></concat>");
	      }
	    } else {
	      out.println("<const value='"+m+"'/></concat>");
	    }
	  }
	}
	out.println("    </union>");
	out.println("  </regexp-def>");
      }
    }


    out.println("  <regexp-def id='isbn'>");
    out.println("    <union>");
    for (int i = 5; i <= 5; i++) {
      for (int j = 0; j <= 10; j++) {
	String name = "isbn"+i+(j == 10 ? "X" : String.valueOf(j));
	defs.add(name);
	out.println("  <regexp idref='"+name+"'/>");
      }
    }
    out.println("    </union>");
    out.println("  </regexp-def>");
    /*
    for (int i = 1; i <= 5; i++) {
      out.println("  <regexp-def id='isbn"+i+"'>");
      out.println("    <union>");
      for (int j = 0; j < defs.size(); j++) {
	String name = defs.get(j).toString();
	if (name.startsWith("isbn"+i)) {
	  out.println("      <regexp idref='"+name+"'/>");
	}
      }
      out.println("    </union>");
      out.println("  </regexp-def>");
    }
    */
    out.println("</powerforms>");
    out.close();
    /* System.out.println(chars); */
    PowerForms pwf = new PowerForms();
    Reader in = new CharArrayReader(chars.toCharArray());
    pwf.initialize(in);

    Automaton[] automatons = new Automaton[11];
    for (int i = 5; i <= 5; i++) {
      for (int j = 0; j <= 10; j++) {
	String name = "isbn"+i+(j == 10 ? "X" : String.valueOf(j));
	automatons[j] = pwf.getAutomaton(name);
	System.err.println(automatons[j]);
	OutputStream output = new FileOutputStream(name+".dfa");
	automatons[j].store(output);
	output.close();
      }
    }

    Automaton isbn = automatons[0];
    for (int i = 1; i < 11; i++) {
      isbn = isbn.union(automatons[i]);
      isbn.minimize();
    }

    /* Automaton isbn = pwf.getAutomaton("isbn"); */
    System.err.println("isbn:\n"+isbn);
    OutputStream output = new FileOutputStream("isbn.dfa");
    isbn.store(output);
    output.close();
  }
}
