/*
 * PowerForms
 * Copyright (C) 1999-2002 BRICS.
 *
 * Author: Mikkel Ricky <ricky@brics.dk>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the  Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 *
 * Home page: http://www.brics.dk/bigwig/powerforms/
 */

package dk.brics.powerforms;

class Token {
  public static final int AND_end = 1000;
  public static final int AND_start = 1001;
  public static final int ANYCHAR_end = 1002;
  public static final int ANYCHAR_start = 1003;
  public static final int ANYTHING_end = 1004;
  public static final int ANYTHING_start = 1005;
  public static final int APPLET_end = 1006;
  public static final int APPLET_start = 1007;
  public static final int AttValue = 1008;
  public static final int CHARRANGE_end = 1009;
  public static final int CHARRANGE_start = 1010;
  public static final int CHARSET_end = 1011;
  public static final int CHARSET_start = 1012;
  public static final int COMPLEMENT_end = 1013;
  public static final int COMPLEMENT_start = 1014;
  public static final int CONCAT_end = 1015;
  public static final int CONCAT_start = 1016;
  public static final int CONSTRAINT_end = 1017;
  public static final int CONSTRAINT_start = 1018;
  public static final int CONST_end = 1019;
  public static final int CONST_start = 1020;
  public static final int COUNT_end = 1021;
  public static final int COUNT_start = 1022;
  public static final int CRAP = 1023;
  public static final int DEFATTR = 1024;
  public static final int ELSE_end = 1025;
  public static final int ELSE_start = 1026;
  public static final int EMPTY_end = 1027;
  public static final int EMPTY_start = 1028;
  public static final int ENDTAG = 1029;
  public static final int EOF = 1030;
  public static final int EQUAL_end = 1031;
  public static final int EQUAL_start = 1032;
  public static final int FORM_end = 1033;
  public static final int FORM_start = 1034;
  public static final int FUNCTION_end = 1035;
  public static final int FUNCTION_start = 1036;
  public static final int IF_end = 1037;
  public static final int IF_start = 1038;
  public static final int IGNORE_end = 1039;
  public static final int IGNORE_start = 1040;
  public static final int INIT_end = 1041;
  public static final int INIT_start = 1042;
  public static final int INPUT_end = 1043;
  public static final int INPUT_start = 1044;
  public static final int INTERSECTION_end = 1045;
  public static final int INTERSECTION_start = 1046;
  public static final int INTERVAL_end = 1047;
  public static final int INTERVAL_start = 1048;
  public static final int LESSTHAN_end = 1049;
  public static final int LESSTHAN_start = 1050;
  public static final int MATCHALL_end = 1051;
  public static final int MATCHALL_start = 1052;
  public static final int MATCH_end = 1053;
  public static final int MATCH_start = 1054;
  public static final int NOT_end = 1055;
  public static final int NOT_start = 1056;
  public static final int Name = 1057;
  public static final int OPTIONAL_end = 1058;
  public static final int OPTIONAL_start = 1059;
  public static final int OPTION_end = 1060;
  public static final int OPTION_start = 1061;
  public static final int OR_end = 1062;
  public static final int OR_start = 1063;
  public static final int PLUS_end = 1064;
  public static final int PLUS_start = 1065;
  public static final int POWERFORMS_end = 1066;
  public static final int POWERFORMS_start = 1067;
  public static final int REGEXP_end = 1068;
  public static final int REGEXP_start = 1069;
  public static final int REPEAT_end = 1070;
  public static final int REPEAT_start = 1071;
  public static final int RESULT_end = 1072;
  public static final int RESULT_start = 1073;
  public static final int SELECT_end = 1074;
  public static final int SELECT_start = 1075;
  public static final int SOMETHING = 1076;
  public static final int STATUS_end = 1077;
  public static final int STATUS_start = 1078;
  public static final int STRINGCONST = 1079;
  public static final int SUBMIT_end = 1080;
  public static final int SUBMIT_start = 1081;
  public static final int TEXTAREA_end = 1082;
  public static final int TEXTAREA_start = 1083;
  public static final int THEN_end = 1084;
  public static final int THEN_start = 1085;
  public static final int UNION_end = 1086;
  public static final int UNION_start = 1087;

  private static String[] tokens = {
    "AND_end", "AND_start", "ANYCHAR_end", "ANYCHAR_start", "ANYTHING_end", "ANYTHING_start", "APPLET_end", "APPLET_start", "AttValue", "CHARRANGE_end", "CHARRANGE_start", "CHARSET_end", "CHARSET_start", "COMPLEMENT_end", "COMPLEMENT_start", "CONCAT_end", "CONCAT_start", "CONSTRAINT_end", "CONSTRAINT_start", "CONST_end", "CONST_start", "COUNT_end", "COUNT_start", "CRAP", "DEFATTR", "ELSE_end", "ELSE_start", "EMPTY_end", "EMPTY_start", "ENDTAG", "EOF", "EQUAL_end", "EQUAL_start", "FORM_end", "FORM_start", "FUNCTION_end", "FUNCTION_start", "IF_end", "IF_start", "IGNORE_end", "IGNORE_start", "INIT_end", "INIT_start", "INPUT_end", "INPUT_start", "INTERSECTION_end", "INTERSECTION_start", "INTERVAL_end", "INTERVAL_start", "LESSTHAN_end", "LESSTHAN_start", "MATCHALL_end", "MATCHALL_start", "MATCH_end", "MATCH_start", "NOT_end", "NOT_start", "Name", "OPTIONAL_end", "OPTIONAL_start", "OPTION_end", "OPTION_start", "OR_end", "OR_start", "PLUS_end", "PLUS_start", "POWERFORMS_end", "POWERFORMS_start", "REGEXP_end", "REGEXP_start", "REPEAT_end", "REPEAT_start", "RESULT_end", "RESULT_start", "SELECT_end", "SELECT_start", "SOMETHING", "STATUS_end", "STATUS_start", "STRINGCONST", "SUBMIT_end", "SUBMIT_start", "TEXTAREA_end", "TEXTAREA_start", "THEN_end", "THEN_start", "UNION_end", "UNION_start"
  };

  private static String[] images = {
    "</and>", "<and", "</anychar>", "<anychar", "</anything>", "<anything", "</applet>", "<applet", "Attribute value", "</charrange>", "<charrange", "</charset>", "<charset", "</complement>", "<complement", "</concat>", "<concat", "</constraint>", "<constraint", "</const>", "<const", "</count>", "<count", "Some invalid html crap ...", "Defattr", "</else>", "<else", "</empty>", "<empty", "/>", "End of file", "</equal>", "<equal", "</form>", "<form", "</function>", "<function", "</if>", "<if", "</ignore>", "<ignore", "</init>", "<init", "</input>", "<input", "</intersection>", "<intersection", "</interval>", "<interval", "</lessthan>", "<lessthan", "</matchall>", "<matchall", "</match>", "<match", "</not>", "<not", "Attribute name", "</optional>", "<optional", "</option>", "<option", "</or>", "<or", "</plus>", "<plus", "</powerforms>", "<powerforms", "</regexp>", "<regexp", "</repeat>", "<repeat", "</result>", "<result", "</select>", "<select", "Text", "</status>", "<status", "String literal", "</submit>", "<submit", "</textarea>", "<textarea", "</then>", "<then", "</union>", "<union"
  };

  static String getImage(int kind) {
    if (kind == Lexer.YYEOF) {
      return "End of file";
    } else if (kind < 1000) {
      return String.valueOf((char)kind);
    }
    return images[kind-1000];
  }
}
